/**
 * 
 */
package nemi.apriori;

import nemi.cluster.Cluster;

import java.util.Vector;

/**
 * A list of labels for an apriori motif.
 */
public class AprioriGraphLabels {
	String labels;
	Vector<Integer> graphPointers;
	int lastNodePtr = -1;

	AprioriGraphLabels(String labels) {
		this.graphPointers = new Vector<Integer>();
		this.labels = labels;
		for(int i = 0; i <labels.length();i++){
			graphPointers.add(i);
		}
		this.lastNodePtr = this.graphPointers.get(graphPointers.size() - 1);
	}

    AprioriGraphLabels(String labels, Vector<Integer> graphPointers) {
		this.labels = labels;
		this.graphPointers = graphPointers;
		this.lastNodePtr = this.graphPointers.get(graphPointers.size() - 1);
	}

	public int length() {
		return this.labels.length();
	}

	public char charAt(int i) {
		return labels.charAt(i);
	}

	public String toString() {
		String pointers = "";
		for (Integer integer : graphPointers) {
			pointers += integer + " ";
		}
		return "GraphLabel: " + labels + ", points to: " + pointers;
	}
}