package nemi.cluster;

import nemi.compare.ProteinCompare;
import nemi.compare.CsaNeighComparer;

import javax.swing.*;
import java.util.HashMap;
import java.util.Collection;

import cytoscape.CyNetwork;

/**
 * A list of available clusterer.
 */
public class ClustererList extends DefaultComboBoxModel {
    public static String itClust = "Iterative clusterer";
    public static String rItClust = "Randomized Iterative clusterer";
    public static String tfCluster = "Transcription factor clusterer";
    public static String csaCluster = "Csa neighborhood clusterer";
    HashMap<String, Clusterer> stringClusterer = new HashMap<String, Clusterer>();

    public ClustererList() {
        this.addElement(itClust);
        this.addElement(rItClust);
        this.addElement(tfCluster);
        this.addElement(csaCluster);
    }

    public Collection<Cluster> cluster(Collection<CyNetwork> networks, ProteinCompare comp,
                                       QualityAssesser.CompareClusterNodeType compareClusterNodetype,
                                       QualityAssesser.CompareClusterType compareClusterType,
                                       double limit, boolean joinSingle) {
        Collection<Cluster> clusters;
        if (this.getSelectedItem().equals(rItClust)) {
            RandIterCluster cl = new RandIterCluster();
            clusters = cl.cluster(networks, comp,
                    QualityAssesser.CompareClusterNodeType.MIN_REP,
                    limit, joinSingle);
        } else if (getSelectedItem().equals(ClustererList.itClust)) {
            // clusterTest();
            IterativeClusterer cl = new IterativeClusterer();
            clusters = cl.cluster(networks, comp,
                    QualityAssesser.CompareClusterNodeType.MIN_REP,
                    limit, joinSingle);
        } else if (getSelectedItem().equals(ClustererList.tfCluster)) {
            clusters = TFClusterer.cluster(networks, joinSingle);
        } else if (getSelectedItem().equals(ClustererList.csaCluster)) {
            CsaIterativeClusterer csaClusterer = new CsaIterativeClusterer();
            CsaNeighComparer neighComp = new CsaNeighComparer(comp);
            clusters = csaClusterer.cluster(networks, neighComp,
                    QualityAssesser.CompareClusterNodeType.MIN_REP,
                    limit, false);

        } else {

            System.out.println("this feature is not implemented");
            return null;

        }
        //To change body of created methods use File | Settings | File Templat
        // es.
        return clusters;
    }

    public boolean requiresProteincomparers(){
        if(getSelectedItem().equals(tfCluster)){
            return false;
        }
        return true;
    }
    public boolean requiresLimit(){
        if(getSelectedItem().equals(tfCluster)){
            return false;
        }
        return true;
    }
}
