package nemi.compare;

import cytoscape.CyNetwork;
import cytoscape.Cytoscape;
import cytoscape.data.FlagEvent;
import cytoscape.data.FlagEventListener;
import giny.model.Node;
import nemi.NetNode;
import nemi.compare.gui.ProteinComparerTable;
import nemi.gui.NeMiFinalView;
import nemi.gui.TableSorter;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.*;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 09.mar.2006
 * Time: 16:02:01
 * GUI for the comparers.
 */
public class ComparerPanel extends JSplitPane implements
        FlagEventListener {

    private JLabel jLabelChosenNode = new JLabel("Please click in a network to choose a node");
    private boolean weightResults = false;
    private JButton jButtonGo = new JButton("Run");
    private JPanel topPanel = new JPanel();
    private JScrollPane scrollPanel = new JScrollPane();
    private ProteinComparerTable prottable = new ProteinComparerTable();
    private CyNetwork currentNet = null;
    private Node curNode = null;
    // private CyNetworkView curView;
    private JTable table;
    NeMiFinalView.StatusInfo statusObject;
    private JLabel runInfoLabel = new JLabel();

    public ComparerPanel(NeMiFinalView.StatusInfo status) {
        //curView = Cytoscape.getCurrentNetworkView();
        //curView.addGraphViewChangeListener(this);
        statusObject = status;
        jButtonGo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                goButtonPressed(e);
            }
        });
        jButtonGo.setEnabled(false);
        prottable.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonGo.setEnabled(prottable.isReady() && curNode != null);


            }
        });
        initComponents();

    }

    public void dispose() {
        //System.out.println("Naa disposer vi CSAProteinFinderpanel");
        //Cytoscape.getCurrentNetworkView().removeGraphViewChangeListener(this);
        for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
            net.removeFlagEventListener(this);
        }
    }

    public static void main(String[] args) {
/*
        JFrame f = new JFrame();
        f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f.getContentPane().add(new CSAProteinFinderPanel(null));
        f.setSize(500, 500);
        f.setVisible(true);
        f.repaint();


        JFrame f1 = new JFrame();
        f1.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f1.getContentPane().add(new JTable(new CSAResults()));
        f1.setSize(500, 500);
        f1.setVisible(true);
        f1.repaint();
        */
    }


    private void initComponents() {

        // top
        jButtonGo.setEnabled(false);
        GridBagLayout gbl = new GridBagLayout();
        topPanel.setLayout(gbl);
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 2;
        c.anchor = GridBagConstraints.WEST;
        topPanel.add(jLabelChosenNode, c);
        c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 1;
        topPanel.add(new JLabel("Compare method"), c);

        c = new GridBagConstraints();
        c.gridy = 1;
        c.gridx = 1;
        JScrollPane scroller = new JScrollPane();
        scroller.setPreferredSize(new Dimension(400, 80));
        scroller.setViewportView(prottable);
        topPanel.add(scroller, c);

        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        c.gridx = 0;
        c.gridy = 2;


        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.WEST;
        c.gridx = 1;
        c.gridy = 3;
        buttonPanel.add(jButtonGo);

        topPanel.add(buttonPanel, c);
        topPanel.setPreferredSize(new Dimension(500, 100));

        //bottom

        table = new JTable();
        //TableSorter sorter = new TableSorter(results);
//        table.setModel(results);
        //sorter.setTableHeade(table.getTableHeader());
        table.setAutoCreateColumnsFromModel(true);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        scrollPanel.setBorder(new javax.swing.border.EtchedBorder());
        scrollPanel.setPreferredSize(new Dimension(300, 200));
        scrollPanel.setViewportView(table);

        //this
        setOrientation(JSplitPane.VERTICAL_SPLIT);
        setDividerLocation(200);
        setTopComponent(topPanel);
        setBottomComponent(scrollPanel);


        setVisible(true);
        repaint();
        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.WEST;
        c.gridx = 0;
        c.gridy = 4;

        topPanel.add(runInfoLabel, c);

    }


    public void goButtonPressed(ActionEvent e) {
        if (curNode != null && currentNet != null) {
            System.out.println("Running Protein compare for " + curNode.getIdentifier());
            jButtonGo.setEnabled(false);
            Thread t = new Thread(new Runnable() {
                public void run() {
                    CyNetwork nettemp = currentNet;
                    Collection<CyNetwork> nets = new Vector<CyNetwork>();
                    nets.add(nettemp);
                    ProteinCompare comp = prottable.getComparer(nets);
                    Vector<Double> similarity = new Vector<Double>();
                    Vector<Node> nodes = new Vector<Node>();
                    runInfoLabel.setText("Displaying results for " + curNode.getIdentifier());
                    for (Iterator<Node> nIter = nettemp.nodesIterator(); nIter.hasNext();) {
                        Node n = nIter.next();
                        if (n.equals(curNode)) continue;
                        double sim = comp.similarity(new NetNode(nettemp, n), new NetNode(nettemp, curNode));
                        similarity.add(sim);
                        nodes.add(n);
                    }

                    NodeWeightTableModel model = new NodeWeightTableModel(nodes, similarity);
                    TableSorter sorter = new TableSorter(model);
                    sorter.setSortingStatus(1,2);
                    sorter.setTableHeader(table.getTableHeader());

                    table.setModel(sorter);
                    runInfoLabel.repaint();

                    scrollPanel.repaint();


                    jButtonGo.setEnabled(prottable.isReady());

                }
            });
            t.start();
        }
    }

    public void onFlagEvent(FlagEvent event) {

        if (event.getEventType()) {

            curNode = ((Set<Node>) event.getSource().getFlaggedNodes()).iterator().next();
            currentNet = Cytoscape.getCurrentNetwork();
            jLabelChosenNode.setText("You have selected " + curNode.getIdentifier() + " in network " +
                    nemi.Toolkit.networkToString(currentNet));
            jLabelChosenNode.repaint();
            jButtonGo.setEnabled(prottable.isReady());

        }
    }
}

/**
 * Table model for the node weights.
 */
class NodeWeightTableModel extends DefaultTableModel {
    private List<Double> similarities = new Vector<Double>();
    private List<Node> nodes = new Vector<Node>();

    NodeWeightTableModel(Vector<Node> nodes, Vector<Double> similarities) {
        super();
        this.nodes = nodes;
        this.similarities = similarities;
    }

    public boolean isCellEditable(int row, int column) {
        return false;
    }

    public Class<?> getColumnClass(int columnIndex) {
        if(columnIndex == 0) return String.class;
        if(columnIndex== 1) return Double.class;
        return super.getColumnClass(columnIndex);
    }

    public int getRowCount() {
        if(nodes==null) return 0;
        return nodes.size();   
    }

    public Object getValueAt(int row, int column) {

        if (column == 0) {
            return nodes.get(row).getIdentifier();
        } else if(column == 1){
            return similarities.get(row);

        }
        return null;

    }

    public int getColumnCount() {
        return 2;
    }

    public String getColumnName(int column) {
        if (column == 0) return "Node Identifier";
        return "Similarity";
    }
}