package nemi.compare;

import nemi.NetNode;

/**
 * NeMi - Neighborhood GSpanMining
 * Distributed AS-IS - No Warranty
 * $Id: ProteinCompare.java 407 2006-06-05 13:11:01Z kristost $
 */
public abstract class ProteinCompare {
    /**
     *  Returns a value for the similarity two protein.
     *  A similarity score of 1.0 means they are equal (or max similarity), and 0.0 means total dissimilarity.
     *
     * @return similarity between 0 and 1.
     */

    abstract public double similarity(NetNode nn1, NetNode nn2);

    /**
     * This method is here so that implementors should remember to add a static field "name" for the GUI.
     * **/
    abstract  public String getName();

}
