package nemi.compare.gui;

import nemi.compare.ProteinCompare;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * NeMi - Neighborhood Mining
 * Distributed AS-IS - No Warranty
 * $Id: ComparerChoserTableEditor.java 407 2006-06-05 13:11:01Z kristost $
 *
 *  Cell editor for the compare chooser.
 */
public class ComparerChoserTableEditor extends AbstractCellEditor implements
        TableCellEditor, ActionListener {

    protected static final String EDIT = "edit";
     public static boolean requiresGO(){
        return false;
    }
    JComboBox goChooser;

    public ComparerChoserTableEditor() {
        super();
        goChooser = new JComboBox();
        for (Class<? extends ProteinCompare> clas : ProteinComparerTable.comparers) {
            try {
                goChooser.addItem(clas.getField("name").get(null));

            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            }
        }

        goChooser.addItem("None");
        goChooser.addActionListener(this);
    }


    public void actionPerformed(ActionEvent e) {
        // The user has clicked the cell, so
        // bring up the dialog.
        fireEditingStopped(); // Make the renderer reappear.
    }

    // Implement the one method defined by TableCellEditor.
    public Component getTableCellEditorComponent(JTable table, Object value,
                                                 boolean isSelected, int row, int column) {
        return goChooser;
    }

    public Object getCellEditorValue() {
        System.out.println("getCellEditorValue" + goChooser.getSelectedItem());
        return goChooser.getSelectedItem();
    }
}
