package nemi.compare.gui;

import cytoscape.data.annotation.AnnotationDescription;
import nemi.compare.ProteinCompare;
import nemi.compare.TransFacCompare;
import nemi.cytoscape.AnnotationList;

import javax.swing.table.DefaultTableModel;
import java.util.Vector;

/**
 * NeMi - Neighborhood Mining
 * Distributed AS-IS - No Warranty
 * $Id: ProteinTableModel.java 453 2006-06-09 13:53:02Z sundsdal $
 * <p/>
 * Model for the protein table.
 */
public class ProteinTableModel extends DefaultTableModel {
    public Vector<Class<? extends ProteinCompare>> comparer;
    public Vector<AnnotationDescription> annotation;
   // public Vector<Boolean> metric;
    public Vector<Integer> weight;
    public Vector<Vector> table = new Vector<Vector>();

    public ProteinTableModel() {
        super();
        comparer = new Vector<Class<? extends ProteinCompare>>();
        annotation = new Vector<AnnotationDescription>();
        //metric = new Vector<Boolean>();
        weight = new Vector<Integer>();

        table.add(comparer);
        table.add(annotation);
        //table.add(metric);
        table.add(weight);
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public Object getValueAt(int row, int column) {
        if (row == table.get(0).size()) {
            if (column == 0)
                return "Press here to add another";
            //if (column == 2)
                return "";
        }
        if (row > table.get(0).size())
            return "";
        if (column == 0) {
            try {
                return ((Class<? extends ProteinCompare>) table.get(column).get(row)).getField("name").get(null);
            } catch (NoSuchFieldException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            } catch (IllegalAccessException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            } catch (NullPointerException e) {
                //TODO:FEIL HER! 
                e.printStackTrace();
            } catch (ClassCastException e) {
                e.printStackTrace();
            }
            return "None";
        }
        return table.get(column).get(row);
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (row < table.get(0).size())
            return true;
        if (column == 0 && row == table.get(0).size())
            return true;
        return false;
    }

    @Override
    public void setValueAt(Object aValue, int row, int column) {
        // System.out.println("Setting " + row + "/" + column + ": " + aValue);
        if (row < table.get(0).size()) {
            //Remove the row and update weights
            if ((aValue == null || aValue.equals("None")) && column == 0) {
                for (int i = 0; i < 3; i++) {
                    table.get(i).remove(row);
                }

                Vector<Integer> weights = table.get(2);
                if (weights.size() > 0) {
                    int sum = 0;
                    for (int val : weights)
                        sum += val;
                    for (int j = (row + 1) % weights.size(); sum != 100; j = (j + 1)
                            % weights.size()) {
                        if (weights.get(j) < 100) {
                            weights.set(j, weights.get(j) + 1);
                            sum++;
                        }
                    }
                }
            } else {
                //Update the table
                if (column == 2) {
                    //the weights needs to be taken care of like this.
                    Vector<Integer> weights = table.get(2);
                    int value = (Integer) aValue;
                    int sum = 0;
                    weights.set(row, value);
                    for (int val : weights)
                        sum += val;
                    if (sum > 100) {
                        for (int j = (row + 1) % weights.size(); sum != 100; j = (j + 1)
                                % weights.size()) {
                            System.out.print(j);
                            if (weights.get(j) > 0) {
                                weights.set(j, weights.get(j) - 1);
                                sum--;
                                break;
                            }
                        }
                    }
                    if (sum < 100) {
                        for (int j = (row + 1) % weights.size(); sum != 100; j = (j + 1)
                                % weights.size()) {
                            System.out.print(j);
                            weights.set(j, weights.get(j) + 1);
                            sum++;
                            break;
                        }
                    }

                } else {
                    if (column == 0) {
                        boolean wasfac = false;
                        if (table.get(0).get(row).equals(TransFacCompare.class)) {
                            wasfac = true;
                        }

                        table.get(0).set(row, ProteinComparerTable.getCompareClass((String) aValue));
                        if (table.get(0).get(row).equals(TransFacCompare.class)) {
                            table.get(1).set(row, "None");
                        } else if (wasfac) {
                            AnnotationList al = new AnnotationList();
                            AnnotationDescription d = al.getSelected();
                            table.get(1).set(row, d);
                        }
                    } else {
                        table.get(column).set(row, aValue);

                    }
                }

            }
        } else if(row == table.get(0).size()){
            if (aValue == null || aValue.equals(null) || aValue.equals("None") || aValue.equals("null"))
            {
                ;
            } else {
                AnnotationList al = new AnnotationList();
                AnnotationDescription d = al.getSelected();
                table.get(0).add(ProteinComparerTable.getCompareClass((String) aValue));
                if (table.get(0).lastElement().equals(TransFacCompare.class)) {
                    table.get(1).add("None");
                } else {
                    table.get(1).add(d);
                }
                //table.get(2).add(false);
                if (row == 0)
                    table.get(2).add(100);
                else
                    table.get(2).add(0);
            }
        } 
        fireTableDataChanged();
    }

    @Override
    public Class<?> getColumnClass
            (
                    int columnIndex) {
        switch (columnIndex) {
            case 0:
                return String.class;
            case 1:
                return String.class;
            case 2:
                return Integer.class;

            default:
                return null;
        }
    }

    @Override
    public int getRowCount
            () {
        // TODO Auto-generated method stub
        if (table == null)
            return 1;
        return table.get(0).size() + 1;
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "Comparator";
            case 1:
                return "Annotation";
            case 2:
                return "Weight";

            default:
                return super.getColumnName(column);
        }
    }

    private int updateRow = 0;

    public int newWeight
            (Integer
                    value, int row) {
        Vector<Integer> weights = table.get(2);
        int sum = 0;
        if (weights.size() == 1) {
            weights.set(0, 100);
            return 100;
        }
        weights.set(row, value);
        for (int n : weights) sum += n;
        while (sum < 100) {
            updateRow = (updateRow + 1) % weights.size();
            if (updateRow == row || weights.get(updateRow) >= 100) {
                continue;
            }
            weight.set(updateRow, weights.get(updateRow) + 1);
            //System.out.println("Setting row " + updateRow + " to " + weights.get(updateRow));
            sum++;


        }
        while (sum > 100) {
            updateRow = (updateRow + 1) % weights.size();
            if (updateRow == row || weights.get(updateRow) <= 0) {
                continue;
            }
            weight.set(updateRow, weights.get(updateRow) - 1);
            sum--;

        }
        for (int j = 0; j < weights.size(); j++) {
            if (j == row) continue;
            fireTableCellUpdated(j, 2);
        }

        fireTableDataChanged();
        return weights.get(row);
    }

    public void clear() {
        for (Vector vector : table) {
            vector.clear();
        }
    }

}
