package nemi.cytoscape;

import cytoscape.Cytoscape;
import cytoscape.data.annotation.AnnotationDescription;

import javax.swing.*;
import java.util.Iterator;
import java.util.Vector;

/**
 * Model for the list of annotations.
 */
public class AnnotationList extends DefaultComboBoxModel implements Iterable<AnnotationDescription> {
	Vector<AnnotationDescription> annotations = new Vector<AnnotationDescription>();
	AnnotationDescription selected = null;
	public AnnotationList() {
		
		for (AnnotationDescription ann : Cytoscape.getBioDataServer()
				.getAnnotationDescriptions()) {
			annotations.add(ann);
		}
		this.fireContentsChanged(this, 0, annotations.size()-1);
	}

	@Override
	public String getElementAt(int index) {
		return annotations.get(index).toString();
	}
	public AnnotationDescription getSelected(){
		if(selected==null && annotations.size()>0){
			selected = annotations.get(0);
		} 
		return selected;
	}
	@Override
	public int getIndexOf(Object anObject) {
		return annotations.indexOf(anObject);
	}
   public AnnotationDescription getIndex(int i ){
	   return annotations.get(i);
   }
	@Override
	public String getSelectedItem() {
		if(selected == null){
			if(annotations.size()>0){
				selected = annotations.get(0);
			} else {
				return "Can't find annotations";
			}
		}
		return selected.toString();
	}

	@Override
	public int getSize() {
		return annotations.size();
	}

	@Override
	public void setSelectedItem(Object anObject) {
		if (anObject instanceof AnnotationDescription) {
            selected = (AnnotationDescription) anObject;
		}  if (anObject instanceof String) {
			String s = (String) anObject;
			for(AnnotationDescription ad :annotations){
				if(ad.toString().equals(s)){
					selected = ad;
					return;
				}
			}
			
			
		}
		else selected = null;
	}

    /**
     * Returns an iterator over a set of elements of type AnnotationDescription.
     *
     * @return an Iterator.
     */
    public Iterator<AnnotationDescription> iterator() {
        return annotations.iterator();
    }
}
