package nemi.cytoscape;

import cytoscape.CyNetwork;
import cytoscape.Cytoscape;
import nemi.Toolkit;

import javax.swing.*;
import java.util.HashMap;
import java.util.Set;

/**
 * A list of available Cytoscape networks.
 */
public class NetworkList extends DefaultComboBoxModel {
    private HashMap<String, CyNetwork> string2net = new HashMap<String, CyNetwork>();
    CyNetwork selected;

    public NetworkList() {
        Set<CyNetwork> nets = Cytoscape.getNetworkSet();
        for (CyNetwork net : nets) {
            String name = Toolkit.networkToString(net);
            string2net.put(name, net);
            this.addElement(name);
        }
        this.fireContentsChanged(this, 0, string2net.size() - 1);
    }

    /**
     * @return The selected network. 
     */
    public CyNetwork getSelectedNetwork() {
        return string2net.get(getSelectedItem());
    }
}
