package nemi.gspan;

import java.util.HashSet;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 05.mai.2006
 * Time: 11:18:40
 *
 * A frequent dfsNode.
 */
public final class DfsResult {
    public final HashSet<ResultInstance> expFreqs = new HashSet<ResultInstance>();
    public final DfsMotif motif;

    public DfsResult(DfsNode node) {
        this.motif = node.motif;
        for (SubgraphInstance instance : node) {
            expFreqs.add(new ResultInstance(instance));
        }
    }
    public String toString(){
        StringBuffer sb = new StringBuffer();
        sb.append("Motif ");
        sb.append(motif.toString());
        sb.append(" with ");
        sb.append(expFreqs.size());
        sb.append(" instances");
        return sb.toString();
    }

    public StringBuffer toStringDetailed() {
        StringBuffer sb = new StringBuffer(toString()+":\n");
        for (ResultInstance instance : expFreqs) {
            sb.append(instance.toString()).append("\n");
        }

        return sb;
    }
}
