package nemi.gspan;

import cytoscape.CyNetwork;
import giny.model.Node;

import javax.swing.tree.TreeNode;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 24.mai.2006
 * Time: 15:37:35
 *
 *  A DfsTreeNode for the DfsTree model implementation.
 */
@SuppressWarnings({"WeakerAccess"})
public final class DfsTreeNode implements TreeNode, Comparable<DfsTreeNode> {
    // DfsNode node;
    Map<CyNetwork, Set<List<Node>>> matchset = new HashMap<CyNetwork, Set<List<Node>>>();
    public final Vector<DfsTreeNode> children = new Vector<DfsTreeNode>();
    private final DfsTreeNode parent;
    public final DfsResult node;
    final List<OrigInstance> origInstances;

    public DfsTreeNode(Map<CyNetwork, Set<List<Node>>> matchset, DfsResult node,
                       DfsTreeNode parent, List<OrigInstance> origInstances) {
        this.origInstances = origInstances;
        this.matchset = matchset;
        this.node = node;
        this.parent = parent;
        if (parent != null) parent.addChild(this);
    }

    private void addChild(TreeNode childNode) {
        children.add((DfsTreeNode) childNode); //sldkfj
    }

    public TreeNode getChildAt(int childIndex) {
        try {
            return children.get(childIndex);  //To change body of implemented methods use File | Settings | File Templates.
        } catch (Exception e) {
            System.out.println("bad2: " + e);
            return null;
        }
    }

    public int getChildCount() {
        return children.size();  //To change body of implemented methods use File | Settings | File Templates.
    }

    public TreeNode getParent() {
        return parent;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public int getIndex(TreeNode node) {
        //noinspection SuspiciousMethodCalls
        return children.indexOf(node);  //To change body of implemented methods use File | Settings | File Templates.
    }

    public boolean getAllowsChildren() {
        return true;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public boolean isLeaf() {
        return children.size() == 0;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public Enumeration children() {
        return new Enumeration() {
            final Iterator<DfsTreeNode> i = children.iterator();

            public boolean hasMoreElements() {
                return i.hasNext();
            }

            public Object nextElement() {
                return i.next();
            }
        };
    }

    private int countMatches() {
        int count = 0;
        for (Map.Entry<CyNetwork, Set<List<Node>>> entry : matchset.entrySet()) {
            count += entry.getValue().size();
        }
        return count;
    }



    private int nodeCount() {
        return node.motif.labels.size();           //WOW!
    }

    public String toString() {
        if (node==null||node.motif == null) return "";
        return nodeCount() + " nodes in  " + countMatches() + " matches and " + matchset.size() + " nets (" + node.motif.toString() + ")";
    }

    public int compareTo(DfsTreeNode o) {
        return nodeCount() - o.nodeCount();
    }
}
