/*
 * NewJFrame.java
 *
 * Created on 25. februar 2006, 13:31
 */

package nemi.gui;

import cytoscape.CyNetwork;
import cytoscape.Cytoscape;
import nemi.apriori.AprioriPanel;
import nemi.compare.ComparerPanel;
import nemi.gspan.GspanPanel;
import nemi.motif.MotifFinderPanel;
import nemi.protein.CSAProteinFinderPanel;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.util.Collection;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Main NeMi window. All other panels are initialized here.
 */
public class NeMiFinalView extends javax.swing.JFrame implements ChangeListener {

    int clusterCount = 0;
    private CSAProteinFinderPanel csapanel;
    private ComparerPanel comparePanel;
    //private JComponent aprioriPanel;
    public static StatusInfo statusObject;
    private AprioriPanel aprioriPanel;

    public class StatusInfo {
        private JProgressBar progress;
        private JLabel label;

        public void repaint() {
            label.repaint();

            progress.repaint();
        }

        public void setStatusInfo(String statuInfo) {
            label.setText(statuInfo);
        }

        public void setProgressText(String progresstext) {

            if (progresstext.length() > 0) {
                progress.setString(progresstext);
                progress.setStringPainted(true);
            } else {
                progress.setStringPainted(false);
            }

        }

        public void setIndeterminate(boolean b) {
            progress.setIndeterminate(b);
        }

        public void setMinimum(int n) {
            progress.setMinimum(n);
        }

        public void setMaximum(int n) {
            progress.setMaximum(n);
        }

        public void setValue(int n) {
            progress.setValue(n);
        }


    }

    /**
     * Creates new scientificFormat NewJFrame
     */
    public NeMiFinalView() {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                initComponents();

                setVisible(true);
            }
        });
        System.gc();


    }

    /**
     * This method is called from within the constructor to initialize the scientificFormat.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated DfsMotif ">
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        nemiToolbar = new javax.swing.JToolBar();
        statusLabel = new javax.swing.JLabel();
        statuspanel = new javax.swing.JPanel();
        tabbedPane = new javax.swing.JTabbedPane();

        tab2Panel = new javax.swing.JPanel();
        nemiMenuBar = new javax.swing.JMenuBar();
        nemiMainMenu = new javax.swing.JMenu();
        exitMenuItem = new javax.swing.JMenuItem();
        nemiHelpMenu = new javax.swing.JMenu();
        nemiAboutMenuItem = new javax.swing.JMenuItem();
        statusProgressbar = new javax.swing.JProgressBar();

        statusObject = new StatusInfo();
        statusObject.progress = statusProgressbar;
        statusObject.label = statusLabel;
        gSpanPanel = new GspanPanel(statusObject);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("NeMi - Neighborhood mining");
        nemiToolbar.setBorder(new javax.swing.border.EtchedBorder());
        statusLabel.setText("Status:");
        nemiToolbar.add(statusLabel);

        nemiToolbar.add(statuspanel);


        nemiToolbar.add(statusProgressbar);
        nemiToolbar.setFloatable(false);
        getContentPane().add(nemiToolbar, java.awt.BorderLayout.SOUTH);

        aprioriPanel = new AprioriPanel(this);

        //tabbedPane.addTab("tab2", tab2Panel);
        tabbedPane.addTab("Motif Finder", new MotifFinderPanel(statusObject));
        csapanel = new CSAProteinFinderPanel(statusObject);
        comparePanel = new ComparerPanel(statusObject);

        tabbedPane.addTab("Protein Finder", csapanel);
        tabbedPane.addTab("Protein comparer", comparePanel);
        tabbedPane.addChangeListener(this);
        tabbedPane.addTab("gSpan graph miner", gSpanPanel);
        tabbedPane.addTab("Apriori graph miner", aprioriPanel);

        getContentPane().add(tabbedPane, java.awt.BorderLayout.CENTER);

        nemiMainMenu.setText("Menu");
        nemiMainMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nemiMainMenuActionPerformed(evt);
            }
        });

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        nemiMainMenu.add(exitMenuItem);

        nemiMenuBar.add(nemiMainMenu);

        final NeMiFinalView view = this;
        nemiHelpMenu.setText("Help");


        JMenuItem h1 = new JMenuItem("Help motif finder");
        h1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JOptionPane.showMessageDialog(view,
                    "Motif finder finds the best match(es) of a given graph (motif) in another, larger \n" +
                    "graph (network).\n\n" +
                            "First select you motif and network. They both have to be already opened in Cytoscape.\n" +
                    "Then select (or implement your own) a protein comparer. This comparer will be used to score node to\n" +
                    "node matches. \n\n" +
                    "The run time of this algorithm is o(motifnodes*networknodes*permutations). The number of possible \n" +
                    "permutations increase drastically as motif size increase. For motifs larger than 10-30 nodes, \n" +
                    "please consider our gSpan implementation.");
            }
        });
        nemiHelpMenu.add(h1);

        JMenuItem h2 = new JMenuItem("Help protein finder");
        h2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JOptionPane.showMessageDialog(view, "Protein finder finds similar nodes based on " +
                    "their neighborhoods.\n\n" +
                    "Be sure to have a network open in Cytoscape. Then select the node you want to \n" +
                    "explore. By using your selected protein comparer, the Protein finder will return \n" +
                    "a list of matching nodes, based on neighborhood. \n\n" +
                    "For example, if your chosen node has 10 neighbors, these 10 neighbors will be \n" +
                    "optimally matched against all other neighborhoods. Other nodes with large neighborhoods \n" +
                    "are likely to give good results. Try the \"weight results\" option to compare all \n" +
                    "assignments to random assignments. Assignments getting high scores in the random runs will get \n" +
                    "a lower score. Please note that the \"weight results\" may slow down run time \n" +
                    "considerably for large neighborhoods.");
            }
        });
        nemiHelpMenu.add(h2);

        JMenuItem h3 = new JMenuItem("Help protein comparer");
        h3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JOptionPane.showMessageDialog(view, "Protein Comparer returns a list of similar nodes based\n" +
                        "on the given similarity measure.\n\n");
            }
        });
        nemiHelpMenu.add(h3);

        JMenuItem h4 = new JMenuItem("Help gSpan graph miner");
        h4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JOptionPane.showMessageDialog(view, "gSpan graph miner finds subgraphs in one or multiple " +
                        "networks\n\n" +
                        "Slect one or more networks and choose a comparer method. \n" +
                        "gSpan runs on labeled graphs, and the network(s) needs to be clustered. \n" +
                        "Nodes appearing in the same clusters will be labeled equal. Nodes appearing in \n" +
                        "several clusters will be duplicated. Cluster tolerance defines how tolerant the clustering\n" +
                        "algorithm should be. Large tolerance will give larger clusters (fewer labels). \n" +
                        "By choosing to join single clusters, all clusters containing only one node after clustering\n" +
                        "will be put in the same cluster. \n\n" +
                        "Minimum support is the lower frequency limit for the resulting subgraphs. When \n" +
                        "mining multiple networks, minimum support is how many networks the returned subgraphs \n" +
                        "have to be in, and when mining a single network, minimum support is how many instances in \n" +
                        "the selected network. \n\n" +
                        "When the search has finished, a list of motifs (the general cases of subgraphs) will appear to the\n" +
                        "left. When selecting a motif, instances will appear in the middle view, and by clicking an instance, \n" +
                        "its nodes will be selected in the Cytoscape view.");
            }
        });
        nemiHelpMenu.add(h4);




        nemiAboutMenuItem.setText("About");
        nemiAboutMenuItem
                .addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        nemiAboutMenuItemActionPerformed(evt);
                    }
                });


        nemiHelpMenu.add(nemiAboutMenuItem);

        nemiMenuBar.add(nemiHelpMenu);

        setJMenuBar(nemiMenuBar);


        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit()
                .getScreenSize();
        //setBounds((screenSize.width - 782) / 2, (screenSize.height - 716) / 2,
        //		782, 716);
        this.setSize(600, 560);
    }

    public void setStatus(String txt) {
        this.statusLabel.setText(txt);
    }

    public JProgressBar getProgressBar() {
        return this.statusProgressbar;
    }
    // </editor-fold>


    private void proteinComparerTableMouseClicked(java.awt.event.MouseEvent evt) {
        if (evt.getClickCount() == 2) {
            System.out.println("Open comparerconfigurator");
        }
    }

    private void nemiAboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
        String t = "NeMi - Neighborhood mining\n\n";
        t += "Tool for finding nodes using neighborhoods, ";
        t += "finding motifs in \nnetworks and";
        t += "mining graph data in single or multiple networks.\n";
        t += "Adapted for biological networks.\n\n";
        t += "Master thesis supervised by Finn Drabl?s and Magnus Lie Hetland \nat the Norwegian University of Science and Technology.\n\n";
        t += "Created by Sverre Sundsdal and ";
        t += "Kristoffer Stenersen.";
        JOptionPane.showMessageDialog(this, t);
    }


    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
        this.setVisible(false);
        this.dispose();
    }

    public void dispose() {
        super.dispose();
        this.csapanel.dispose();
        for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
            net.removeFlagEventListener(csapanel);
        }
    }


    private void addProteinComparerButtonActionPerformed(
            java.awt.event.ActionEvent evt) {

        final JFrame frame = this;
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ProteinComparerDialog ccd = new ProteinComparerDialog(frame);
                ccd.setVisible(true);
            }
        });

    }

    private void nemiMainMenuActionPerformed(java.awt.event.ActionEvent evt) {
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new NeMiFinalView().setVisible(true);
            }
        });
    }
    /*
     public void goButtonPressed(ActionEvent evt) {
         statusProgressbar.setValue(task.getCurrent());
         String s = task.getMessage();
         if (s != null) {
             taskOutput.append(s + newline);
             taskOutput.setCaretPosition(
                     taskOutput.getDocument().getLength());
         }
         if (task.isDone()) {
             Toolkit.getDefaultToolkit().beep();
             timer.stop();
             startButton.setEnabled(true);
             setCursor(null); //turn off the wait cursor
             progressBar.setValue(progressBar.getMinimum());
         }

     }
     */


    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JTabbedPane tabbedPane;
    private GspanPanel gSpanPanel;
    //private javax.swing.JTextArea miningResultTextArea;
    private javax.swing.JMenuItem nemiAboutMenuItem;
    private javax.swing.JMenu nemiHelpMenu;
    private javax.swing.JMenu nemiMainMenu;
    private javax.swing.JMenuBar nemiMenuBar;
    private javax.swing.JToolBar nemiToolbar;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JProgressBar statusProgressbar;
    private javax.swing.JPanel statuspanel;
    private javax.swing.JPanel tab2Panel;
    // End of variables declaration

    public void stateChanged(ChangeEvent e) {
        for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
            net.removeFlagEventListener(csapanel);
            net.removeFlagEventListener(comparePanel);
        }
        //System.out.println(e.getSource().getClass());
        JTabbedPane pane = (JTabbedPane) e.getSource();
        if (pane.getSelectedComponent() instanceof CSAProteinFinderPanel) {
            for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
                net.addFlagEventListener(csapanel);
            }
        } else if (pane.getSelectedComponent() instanceof ComparerPanel) {
            for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
                net.addFlagEventListener(comparePanel);
            }
        }
        statusProgressbar.setIndeterminate(false);
        statusProgressbar.setMinimum(0);
        statusProgressbar.setValue(0);
        statusProgressbar.setString("");
        statusLabel.setText("");
        statusLabel.repaint();
        statusProgressbar.repaint();

    }

}
