package nemi.gui;

import cytoscape.CyNetwork;
import cytoscape.Cytoscape;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import java.util.List;
import java.util.Set;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 19.apr.2006
 * Time: 16:06:29
 * To change this template use File | Settings | File Templates.
 */
public class NetworkSelector extends JTable {

    NetworkTableModel model ;

    public NetworkSelector() {
        super();
        Set<CyNetwork> nets = Cytoscape.getNetworkSet();
        model = new NetworkTableModel(new Vector<CyNetwork>(nets));
        model.fireTableDataChanged();
        this.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        //this.setPreferredSize(new Dimension(400, 100));
        this.setModel(model);
        this.getColumnModel().getColumn(0).setPreferredWidth(20);

        this.repaint();

    }

    public List<CyNetwork> getSelected(){
        List<CyNetwork> selected = new Vector<CyNetwork>();
        for (int i = 0; i < model.getRowCount(); i++) {
            if(model.getValueAt(i, 0).equals(true)){
                selected.add((CyNetwork)model.nets.get(i));
            }
        }
        return selected;
    }


    private class NetworkTableModel extends AbstractTableModel {
        List<CyNetwork> nets;
        List<Boolean> selectedNets;

        public NetworkTableModel(List<CyNetwork> nets) {
            this.nets = nets;
            selectedNets = new Vector<Boolean>(nets==null?0:nets.size());
            for (CyNetwork cyNetwork : nets) {
                selectedNets.add(false);
            }

        }
        public String getColumnName(int col){
            if (col == 1) return "Network name";
            if (col == 0) return "Select";
            return "";
        }

        public void setValueAt(Object val, int row, int column) {
            if (column == 0 && val instanceof Boolean) {
                selectedNets.set(row, (Boolean)val);
                fireTableDataChanged();
            }
        }

        public boolean isCellEditable(int r, int c) {
            //System.out.println("editable: " + r + ": " + c);
            if (c == 0) return true;
            return false;
        }

        public int getRowCount() {
            return nets.size();  //To change body of implemented methods use File | Settings | File Templates.
        }

        public int getColumnCount() {
            return 2;
        }

        public Object getValueAt(int row, int col) {
            switch (col) {
                case 0:
                    return selectedNets.get(row);
                case 1:
                    return nemi.Toolkit.networkToString(nets.get(row));
                default:
                    return "";
            }
        }

        public Class<?> getColumnClass(int column) {
            switch (column) {
                case 0:
                    return Boolean.class;
                case 1:
                    return String.class;
                default:
                    return Object.class;
            }

        }
    }

    public static void main(String[] args) {
        JFrame f = new JFrame();
        f.getContentPane().add(new NetworkSelector());
        f.setSize(300, 300);
        f.setVisible(true);

    }
}
