package nemi.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 03.apr.2006
 * Time: 16:15:32
 * General slider wrapper
 */
public class SliderWrapper extends JPanel {
    JSlider slider;
    JLabel label;

    public void setMin(int min) {
        slider.setMinimum(min);
        if (slider.getValue() < min) {
            slider.setValue(min);
        }
        repaint();
    }
    public void setEnabled(boolean b){
        slider.setEnabled(b);
        label.setEnabled(b);
        if(plusButton!=null) plusButton.setEnabled(b);
        if(minusButton!=null) minusButton.setEnabled(b);
    }

    public void setMax(int max) {
        slider.setMaximum(max);
        if (slider.getValue() > max) {
            slider.setValue(max);
        }
        repaint();
    }

    public void setDivider(double divider) {
        this.divider = divider;
    }

    public void setValue(int val) {
        slider.setValue(val);
        repaint();
    }


    double divider;
     public SliderWrapper(int min, int max, double divider){
         this(min, max, divider, false);
     }

    public SliderWrapper(int min, int max, double divider, boolean spinner) {
        this.setLayout(new GridBagLayout());
        slider = new JSlider();
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        this.add(slider, gridBagConstraints);
        label = new JLabel();

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        slider.setMinimum(min);
        slider.setMaximum(max);
        slider.setValue((max - min) / 2);

        slider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderStateChanged(evt);

            }
        });

        this.divider = divider;
        if (spinner) {
             plusButton = new JButton("+");
            plusButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    plusButtonPressed();
                }
            });

             minusButton = new JButton("-");
            minusButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    minusButtonPressed();
                }
            });
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 2;
            gridBagConstraints.gridy = 0;
            this.add(minusButton, gridBagConstraints);
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 3;
            gridBagConstraints.gridy = 0;
            this.add(plusButton, gridBagConstraints);

        }
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        label.setText("" + (double) slider.getValue() / divider);
        this.add(label, gridBagConstraints);


    }
    JButton plusButton = null;
    JButton minusButton = null;

    public void plusButtonPressed() {
        int max = slider.getMaximum();
        int val = slider.getValue();
        if (val < max) {
            slider.setValue(val + 1);
            label.setText("" + (val + 1) / divider);
            repaint();
        }

    }

    public void minusButtonPressed() {
        int min = slider.getMinimum();
        int val = slider.getValue();
        if (val > min) {
            slider.setValue(val - 1);
            label.setText("" + (val - 1) / divider);
            repaint();
        }

    }

    void sliderStateChanged(javax.swing.event.ChangeEvent evt) {
        label.setText("" + (double) slider.getValue() / divider);
        repaint();

    }

    public double getValue() {
        return slider.getValue() / divider;
    }
}
