package nemi.gui;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 24.feb.2006
 * Time: 11:06:13
 * Default model for displaying results. 
 */
public abstract class ViewableResults extends DefaultTableModel implements ListSelectionListener {
    // from AbstractTableModel
    public abstract int getRowCount();
    public abstract int getColumnCount();
    public abstract Object getValueAt(int rowIndex, int columnIndex);
    public abstract String getColumnName(int columnIndex);
    public abstract Class<?> getColumnClass(int columnIndex);
    public boolean isCellEditable(int rowIndex, int columnIndex) {return false;};

    // selection changed
    public abstract void valueChanged(ListSelectionEvent e);
    public abstract void stopRunning();
    public abstract String getToolTipText(int rowIndex);

}
