package nemi.old;

import nemi.motif.Assignment;
import nemi.motif.MotifFinder;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Set;
import java.util.TreeMap;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class AssignmentResultsFrame extends JFrame implements ListSelectionListener {

    private TreeMap<Assignment, Assignment> results;
    private int maxResults;
    private AbstractTableModel model;
    private MotifFinder motifFinder;

    public AssignmentResultsFrame(int maxResults, MotifFinder motifFinder) {
        super("Search results");
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        this.motifFinder = motifFinder;
        results = new TreeMap<Assignment, Assignment>(new AssignmentComparator());
        this.maxResults = maxResults;
        model = new MyTableModel();
        table.setModel(model);
        table.setAutoCreateColumnsFromModel(true);
        Dimension prefSize = new Dimension(300, 300);
        table.setPreferredSize(prefSize);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        ListSelectionModel rowSM = table.getSelectionModel();
        rowSM.addListSelectionListener(this);
        this.pack();
        this.setVisible(true);
        this.setSize(prefSize);
        this.repaint();


    }

    /**
     * Flagging the selected assignments' nodes.
     * @param e
     */
    public void valueChanged(ListSelectionEvent e) {
        //Ignore extra messages.
        if (e.getValueIsAdjusting()) return;

        ListSelectionModel lsm =
            (ListSelectionModel)e.getSource();
        if (lsm.isSelectionEmpty()) {

        } else {
            int selectedRow = lsm.getMinSelectionIndex();
            Object[] arr = results.values().toArray();
            if (selectedRow >= 0 && selectedRow < arr.length) {
                Assignment ass = (Assignment)arr[arr.length-selectedRow-1];
                motifFinder.setFlagMotifNodes(ass);
                motifFinder.setFlagNetworkNodes(ass);
            }
        }
    }

    /**
     * Overriding the tooltiptext
     */
    class MyTable extends JTable {
         public MyTable() {
             super();
         }

        public String getToolTipText(MouseEvent e) {
            String tip = null;
            java.awt.Point p = e.getPoint();
            int rowIndex = rowAtPoint(p);

            Object[] arr = results.values().toArray();
            if (rowIndex >= 0 && rowIndex < arr.length)
                tip = ((Assignment)(arr[arr.length-rowIndex-1])).toHtml();
            return tip;
        }
    }

    public void addAssignment(Assignment ass) {
        results.put(ass, ass);
        model.fireTableDataChanged();
        this.repaint();
        //model.fireTableStructureChanged();

    }
    public void purgeLessScore(double score){
        Set<Assignment> aset = new HashSet<Assignment>();
        for(Assignment a: results.keySet()){
            if(a.score < score){
                aset.add(a)  ;
            }
        }
        for (Assignment a : aset){
            results.remove(a);
        }
    }


    private void jbInit() throws Exception {
        this.setLayout(new BorderLayout());
        this.add(table.getTableHeader(), BorderLayout.PAGE_START);
        this.add(table, BorderLayout.CENTER);
        /*this.getContentPane().setLayout(borderLayout1);
        this.getContentPane().add(table, java.awt.BorderLayout.NORTH);
        */
    }

    class MyTableModel extends AbstractTableModel {

        public int getRowCount() {
            return results.size() > maxResults ? maxResults : results.size();  //To change body of implemented methods use File | Settings | File Templates.
        }

        public int getColumnCount() {

            return 2;  //To change body of implemented methods use File | Settings | File Templates.
        }

        public String getColumnName(int columnIndex) {
            switch(columnIndex) {
                case 0:
                    return "Number of assignments";
                case 1:
                    return "Assignment score";
            }
            return "THojo";  //To change body of implemented methods use File | Settings | File Templates.
        }

        public Class<?> getColumnClass(int columnIndex) {
            return String.class;
        }

        public boolean isCellEditable(int rowIndex, int columnIndex) {
            return false;  //To change body of implemented methods use File | Settings | File Templates.
        }

        public Object getValueAt(int rowIndex, int columnIndex) {

            try {
                Object[] arr = results.values().toArray();
                switch(columnIndex) {
                    case 0:
                        return ((Assignment)arr[arr.length-rowIndex-1]).getMotifNodes().size();
                    case 1:
                        return ((Assignment)arr[arr.length-rowIndex-1]).score;
                }
            }    catch (Exception e) {
                return e.toString();
            }
            return null;  //To change body of implemented methods use File | Settings | File Templates.
        }


    }

    class AssignmentComparator implements Comparator {
        public int compare(Object o1, Object o2) {
            if (o1 instanceof Assignment && o2 instanceof Assignment) {
                double diff = (((Assignment)o1).score - ((Assignment)o2).score);
                if (diff == 0.0) return 0;
                else return diff < 0 ? -1 : 1;
            }
            else
                return 0;  //To change body of implemented methods use File | Settings | File Templates.
        }
    }


    JTable table = new MyTable();
    BorderLayout borderLayout1 = new BorderLayout();
}
