package nemi.old;

import nemi.protein.Csa;

import java.util.Random;


/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 27.jan.2006
 * Time: 14:40:40
 * Test class for comparing the Hungarian method to the Cost Scaling Algorithm.
 */
public class BipartiteMatcher {

    public static void main(String[] args) {
        /*int[][] tabell = new int[][] {{3,4,50},{1,2,3},{2,3,4}};
        int[] res = BipartiteMatcher.match(tabell);
        System.out.println(res);
        for (int i : res) {
            System.out.println(i);
        } */

        for (int i = 1; i < 1E6; i *= 2) {
            int[][] table = generateTable(i, 1000, 0);
            long start = System.nanoTime();
            Csa csa = new Csa(table);
            csa.getMinCost();
            long used = System.nanoTime() - start;
            start = System.nanoTime();
            // BipartiteMatcher.match(table);
            long elapsed = System.nanoTime() - start;
            System.out.println("nodes: " + i + " took " + elapsed / (float) 1E9 + " csa took: " + used / (float) 1E9);
        }
    }

    public static int[][] generateTable(int size, int range, int min) {
        Random r = new Random();
        int[][] table = new int[size][size];
        for (int[] ints : table) {
            for (int i = 0; i < ints.length; i++) {
                ints[i] = r.nextInt(range) - min;
            }
        }
        return table;
    }

    //  http://forums.topcoder.com/?module=Thread&threadID=508119&start=0&mc=10#518681
    public static int[] match(int[][] scores) {
        int n = scores.length;
        int[] result = new int[n];

        for (int i = 0; i < n; i++) {
            result[i] = i;
        }

        while (improve(scores, result)) ;

        return result;
    }

    private static boolean improve(int[][] scores, int[] permutation) {
        int n = scores.length;
        int[][] weights = new int[n][n];
        int[][] weights2 = new int[n][n];
        int[][] prev = new int[n][n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                weights[i][j] = -scores[i][i] + scores[i][j];
                weights2[i][j] = weights[i][j];
                prev[i][j] = i;
            }
        }


        boolean done = false;
        while (!done) {
            done = true;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    for (int k = 0; k < n; k++) {
                        int possible = weights2[i][k] + weights[k][j];
                        if (possible > weights2[i][j]) {
                            weights2[i][j] = possible;
                            prev[i][j] = k;
                            done = false;
                        }
                    }

                    if (i == j && weights2[i][j] > 0) {
                        int[] tmp = scores[i];
                        int tmp2 = permutation[i];

                        int index;
                        for (index = i; prev[i][index] != i;
                             index = prev[i][index]) {

                            scores[index] = scores[prev[i][index]];
                            permutation[index] = permutation[prev[i][index]];
                        }
                        scores[index] = tmp;
                        permutation[index] = tmp2;
                        return true;
                    }
                }
            }
        }
        return false;
    }
}
