package nemi.old;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.io.PajekNetReader;
import edu.uci.ics.jung.visualization.*;
import edu.uci.ics.jung.visualization.SpringLayout;
import edu.uci.ics.jung.visualization.contrib.CircleLayout;
import edu.uci.ics.jung.visualization.contrib.KKLayout;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 19.jan.2006
 * Time: 14:55:57
 * To change this template use File | Settings | File Templates.
 */
public class JungGraphViewer {
    // Jung's visualization pane
    private JPanel backPanel;
    private JPanel graphPanel;
    private JComboBox selLayoutComboBox;
    private JFrame jf;
    private JSplitPane split;

    public JungGraphViewer(Graph g){

        jf = new JFrame();

        backPanel = new JPanel();

        AbstractLayout[] layouts = new AbstractLayout[]{
                new KKLayout(g),
                new FRLayout(g),
                new SpringLayout(g),
                new ISOMLayout(g),
                new CircleLayout(g)
        };

        selLayoutComboBox = new JComboBox(layouts);
        graphPanel = new VisualizationViewer(layouts[0], new PluggableRenderer());
        split = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        split.add(selLayoutComboBox, 0);
        split.add(graphPanel, 1);
        backPanel.add(split);


        selLayoutComboBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JComboBox box = (JComboBox)e.getSource();
                split.remove(graphPanel);
                graphPanel = new VisualizationViewer((AbstractLayout)box.getSelectedItem(), new PluggableRenderer());
                split.add(graphPanel, 1);
                jf.repaint();
            }
        });

        jf.getContentPane().add(this.backPanel);
        jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        jf.pack();
        jf.setSize(900, 900);
        jf.setVisible(true);
    }

    public static Graph readJungGraph(String fromFile){
        try {
            PajekNetReader pnr = new PajekNetReader();
            Graph g = pnr.load(fromFile);
            return g;
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void main(String[] args)
    {
        Graph g = readJungGraph("./../data/simple.net");
        new JungGraphViewer(g);
    }

 }
