package nemi.protein;

import cytoscape.CyNetwork;
import cytoscape.Cytoscape;
import cytoscape.data.FlagEvent;
import cytoscape.data.FlagEventListener;
import giny.model.Node;
import nemi.NetNode;
import nemi.compare.ProteinCompare;
import nemi.compare.gui.ProteinComparerTable;
import nemi.gui.MessagePane;
import nemi.gui.NeMiFinalView;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: kristost
 * Date: 09.mar.2006
 * Time: 16:02:01
 * GUI for the CSA miner.
 */
public class CSAProteinFinderPanel extends JSplitPane implements
        ActionListener, FlagEventListener, ItemListener {

    private JLabel jLabelChosenNode = new JLabel("Please click in a network to choose a node");
    private JLabel jLabelWeighResults = new JLabel("Weight results");
    private JCheckBox jCheckWeightResults = new JCheckBox();
    private boolean weightResults = false;
    private JButton jButtonGo = new JButton("Run");
    private JPanel topPanel = new JPanel();
    private JScrollPane scrollPanel = new JScrollPane();
    private ProteinComparerTable prottable = new ProteinComparerTable();
    private NetNode curNode = new NetNode(null, null);
    // private CyNetworkView curView;
    private CSAResults results;
    private JTable table;
    private MessagePane messagePane;
    private JButton jButtonSaveResults = new JButton("Save results");
    private CSAProteinFinder csa = new CSAProteinFinder();
    NeMiFinalView.StatusInfo statusObject;
    private JLabel runInfoLabel = new JLabel();

    public CSAProteinFinderPanel(NeMiFinalView.StatusInfo status) {
        messagePane = new MessagePane();
        //curView = Cytoscape.getCurrentNetworkView();
        //curView.addGraphViewChangeListener(this);
        statusObject = status;
        jButtonGo.addActionListener(this);
        jCheckWeightResults.addItemListener(this);
        jCheckWeightResults.setSelected(false);
        jButtonSaveResults.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                results.saveToFile();
            }
        });
        jButtonGo.setEnabled(false);
        prottable.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (prottable.isReady() && curNode != null && curNode.net != null && curNode.node != null) {
                    jButtonGo.setEnabled(true);
                } else {
                    jButtonGo.setEnabled(false);
                }


            }
        });
        initComponents();

    }

    public void dispose() {
        //System.out.println("Naa disposer vi CSAProteinFinderpanel");
        //Cytoscape.getCurrentNetworkView().removeGraphViewChangeListener(this);
        for (CyNetwork net : (Collection<CyNetwork>) Cytoscape.getNetworkSet()) {
            net.removeFlagEventListener(this);
        }
    }

    public static void main(String[] args) {
/*
        JFrame f = new JFrame();
        f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f.getContentPane().add(new CSAProteinFinderPanel(null));
        f.setSize(500, 500);
        f.setVisible(true);
        f.repaint();


        JFrame f1 = new JFrame();
        f1.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f1.getContentPane().add(new JTable(new CSAResults()));
        f1.setSize(500, 500);
        f1.setVisible(true);
        f1.repaint();
        */
    }


    private void initComponents() {
        jButtonSaveResults.setEnabled(false);

        // top
        jButtonGo.setEnabled(false);
        GridBagLayout gbl = new GridBagLayout();
        topPanel.setLayout(gbl);
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 2;
        c.anchor = GridBagConstraints.WEST;
        topPanel.add(jLabelChosenNode, c);
        c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 1;
        topPanel.add(new JLabel("Compare method"), c);

        c = new GridBagConstraints();
        c.gridy = 1;
        c.gridx = 1;
        JScrollPane scroller = new JScrollPane();
        scroller.setPreferredSize(new Dimension(400, 80));
        scroller.setViewportView(prottable);
        topPanel.add(scroller, c);

        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        c.gridx = 0;
        c.gridy = 2;
        topPanel.add(jCheckWeightResults, c);

        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.WEST;
        c.gridx = 1;
        c.gridy = 2;
        topPanel.add(jLabelWeighResults, c);


        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.WEST;
        c.gridx = 1;
        c.gridy = 3;
        buttonPanel.add(jButtonGo);
        buttonPanel.add(jButtonSaveResults);

        topPanel.add(buttonPanel, c);
        topPanel.setPreferredSize(new Dimension(500, 100));

        //bottom

        results = new CSAResults(messagePane);
        table = new JTable();
        //TableSorter sorter = new TableSorter(results);
        table.setModel(results);
        //sorter.setTableHeade(table.getTableHeader());
        table.setAutoCreateColumnsFromModel(true);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        scrollPanel.setBorder(new javax.swing.border.EtchedBorder());
        scrollPanel.setPreferredSize(new Dimension(300, 200));
        scrollPanel.setViewportView(table);

        //this
        setOrientation(JSplitPane.VERTICAL_SPLIT);
        setDividerLocation(200);
        setTopComponent(topPanel);
        JSplitPane bottomSplit = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        bottomSplit.setDividerLocation(300);
        setBottomComponent(bottomSplit);

        bottomSplit.setLeftComponent(scrollPanel);
        bottomSplit.setRightComponent(messagePane);

        setVisible(true);
        repaint();
        c = new GridBagConstraints();
        c.anchor = GridBagConstraints.WEST;
        c.gridx = 0;
        c.gridy = 4;

        topPanel.add(runInfoLabel, c);

    }


    public void actionPerformed(ActionEvent e) {
        if (curNode.net != null && curNode.node != null) {
            System.out.println("Running CSAProteinFinder");
            jButtonGo.setEnabled(false);
            Thread t = new Thread(new Runnable() {
                public void run() {
                    CyNetwork nettemp = curNode.net;
                    Collection<CyNetwork> nets = new Vector<CyNetwork>();
                    nets.add(nettemp);
                    ProteinCompare comp = prottable.getComparer(nets);

                    java.util.List<CSAProteinFinder.CsaMatch>  matches =
                            csa.compareToAllNeighbours(curNode, comp, statusObject, weightResults);
                    table.getSelectionModel().removeListSelectionListener(results);

                    results.setResults(matches, nettemp, weightResults,
                            nemi.Toolkit.getNeighbors(curNode).size(), curNode.node, comp);
                    runInfoLabel.setText("Displaying results for " + curNode.node.getIdentifier());

                    jButtonSaveResults.setEnabled(true);
                    //scrollPanel.repaint();
                    //table.repaint();
                    results.fireTableDataChanged();
                    //results.fireTableRowsInserted(0, matches.size());
                    table.getSelectionModel().addListSelectionListener(results);
                    runInfoLabel.repaint();
                    table.repaint();
                    
                    //repaint();
                    //getComponent(1).repaint();
                    scrollPanel.doLayout();
                    //nemiView.repaint();
                    System.out.println("CSAProteinFinderPanel found " + matches.size() + " matches.");
                    if (prottable.isReady()) {
                        jButtonGo.setEnabled(true);
                    }

                }
            });
            t.start();
        }
    }

    public void onFlagEvent(FlagEvent event) {

        if (event.getEventType()) {
            NetNode n = new NetNode(null, null);
            try {
                n.node = ((Set<Node>) event.getSource().getFlaggedNodes()).iterator().next();
                n.net = Cytoscape.getCurrentNetwork();
            } catch (Exception e){};
            if (n.net == null || n.node == null) return;
            curNode = n;
            jLabelChosenNode.setText("You have selected " + curNode.node.getIdentifier() + " in network " +
                    nemi.Toolkit.networkToString(curNode.net));
            jLabelChosenNode.repaint();
            if (prottable.isReady()) {
                jButtonGo.setEnabled(true);
            } else {
                jButtonGo.setEnabled(false);
            }

        }
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void itemStateChanged(ItemEvent e) {
        if (e.getItemSelectable() == this.jCheckWeightResults) {
            this.weightResults = !this.weightResults;
        }
    }
}

/**
 * Class for printing and comparing results from multiple runs. Writes a list of scores
 * for each run, for each node, to file.
 */
class CsaWeightingStatistics {

    static Map<Node, String> node2score = new HashMap<Node, String>();

    public static void addMatches(Collection<CSAProteinFinder.CsaMatch> matches, boolean last) {
        for (CSAProteinFinder.CsaMatch m : matches) {
            if (!node2score.containsKey(m.target.node))
                node2score.put(m.target.node, new String());
            String s = node2score.get(m.target.node);
            s += m.score + " ";
            if (last)
                s += m.targetNeighs + " ";
            node2score.put(m.target.node, s);
        }
    }

    public static void print() {

        try {
            File f = new File("csaWeighing.txt");
            FileWriter fw = new FileWriter(f, false);
            for (Map.Entry<Node, String> entry : node2score.entrySet()) {
                fw.write("#" + entry.getKey().getIdentifier() + "\n");
                fw.write(entry.getValue() + "\n");
            }
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }
}

